#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

typedef struct
{
  int start;
  int end;
  int sum;
  char c;
} STATE;

/**
   Sum from start (incl) to end (excl)
 */
void* runner(void *param)
{
  STATE *s = param;
  s->sum = 0;

  for(int i = s->start; i < s->end; ++i) {
    s->sum += i;
    printf("%c", s->c);
    fflush(stdout);
    sleep(1);
  }
  
  pthread_exit(0);
}

int main(int argc, char** argv)
{
  STATE s1;
  STATE s2;

  s1.start = 2;
  s1.end = 5;
  s1.c = 'a';

  s2.start = 5;
  s2.end = 10;
  s2.c = 'b';

  pthread_t tid1;  // Thread ID
  pthread_t tid2;  // Thread ID
  pthread_attr_t attr;  // Thread attributes
  
  pthread_attr_init(&attr);
  
  // Create thread
  pthread_create(&tid1, &attr, runner, &s1);
  pthread_create(&tid2, &attr, runner, &s2);

  // Wait for thread to be done
  pthread_join(tid1, NULL);
  pthread_join(tid2, NULL);

  printf("SUM: %d\n", s1.sum + s2.sum);
}
