#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <unistd.h>

typedef struct
{
  int start;
  int end;
  long long sum;
  char c;
} STATE;

/**
   Sum from start (incl) to end (excl)
 */
void* runner(void *param)
{
  STATE *s = param;
  s->sum = 0;

  for(int i = s->start; i < s->end; ++i) {
    s->sum += i;
    printf("%c", s->c);
    fflush(stdout);
    //sleep(1);
  }
  
  pthread_exit(0);
}

#define N 1000
#define N_THREADS 10

int main(int argc, char** argv)
{
  STATE s[N_THREADS];
  const int n_each = N/N_THREADS;

  pthread_t tid[N_THREADS];  // Thread IDs
  pthread_attr_t attr;  // Thread attributes
  
  pthread_attr_init(&attr);

  for(int i=0; i < N_THREADS; ++i) {
    s[i].start = i * n_each;
    
    if(i == N_THREADS-1)
      s[i].end = N;
    else
      s[i].end = (i+1) * n_each;
    
    s[i].c = 'a' + i;
    pthread_create(&(tid[i]), &attr, runner, &(s[i]));
  }

  long long total = 0.0;
  for(int i=0; i < N_THREADS; ++i) {
    pthread_join(tid[i], NULL);
    total += s[i].sum;
  }

  printf("SUM: %lld\n", total);
}
